
#ifndef __CAR_WORLD_H_
#define __CAR_WORLD_H_

#include "H_Standard.h"
#include "CarWorldClasses.h"
#include "CWCamera.h"

#define EARTH_GRAVITY 9.8f

//feel of commands
#define STEER_INCREMENT	.2

//World caracteristics:
#define INIT_TIME_INCREMENT 0.0001f
#define MIN_TIME_CLICKS_SEC 40.0
#define DEFAULT_TIME_CLICKS_PER_FRAME 1

class CarWorld
{
public:
	CarWorld(int TimeRefreshRate);
	~CarWorld();
	void add(CWFeature *AFeature);
	void next_camera();
	void DrawOnScreen();

	void reset();
	void update(int ElapsedTimeMs);
	void draw_init();
	void draw_shutdown();
	void draw();
public:
	CWLandscape *m_Landscape;
	CWCamera *m_Camera; //the current camera
private:
	CWBackground *m_Background;

	list<CWFeature*> m_Features;

	//to do with time scaling:
	int RealTime; //in ms since start
	int Frames;
	int NbTimeClicksPerFrame;
	REAL fps;
	int MyTimeRefreshRate;
public:
	bool draw_console;
	bool draw_background;
	Point3D LightDirection;
};

#endif //__CAR_WORLD_H_
