
#ifndef _CAR_WORLD_CLIENT_H_
#define _CAR_WORLD_CLIENT_H_

namespace std {}
using namespace std;

#include "H_Main.h"

#include "H_Input.h"
#include "H_Prompt.h"
#include "H_Variable.h"
#include "CarWorld.h"

#include <queue>

class CarWorldClient : public HglApplication
{
public:
	CarWorldClient(int argc, char **argv);
	virtual ~CarWorldClient();
//overrided inherited methods
	const char *name();
	const char *version();
	
	void draw_init();
	void draw_shutdown();

	void key_down(H_KEY AHKey, char c);
	void resize(unsigned int width, unsigned int height);
	void on_idle(unsigned int elapsed_time);

	unsigned int init_width();
	unsigned int init_height();
	bool init_full_screen();

	void draw();

//methods particular to CarW, executable from the command line
	void toggleconsole();

	void set_in_type(HInput::Type t);
	HInput::Type get_in_type();

	void set_r_mode(int mode); //screen mode manipulation (not 100% yet...)
	int get_r_mode();

	void execute_cfg(const char *FileName);
	void pars_command(const char *value);

	void bind(H_KEY key,const char *command);

	void print_help();
	void print_version();

	void write_cfg(ostream &out);
public:
	map<H_KEY,string> KeyBindings;
private:
//graphics
	Hgl_ostream hout;
	Hgl *m_Hgl;
//command line
	bool IsPromptMode;
	map<string,HExecutable*> m_Executables;
	queue<string> CommandQ;
//CarWorld
	CWVehicle *m_Vehicle;
	CarWorld *m_CarWorld;
//defaults:
	unsigned int width, height;
	bool full_screen;
};

#endif //_CAR_WORLD_CLIENT_H_
