
#ifndef _H_KEYS_H_
#define _H_KEYS_H_

#include "H_Standard.h"

//Virtual Keys, Standard Set same as Windows VK_*

typedef int H_KEY;

#define HK_INVALID        -1
#define HK_LBUTTON        0x01
#define HK_RBUTTON        0x02
#define HK_CANCEL         0x03
#define HK_MBUTTON        0x04
#define HK_BACK           0x08
#define HK_TAB            0x09
#define HK_CLEAR          0x0C
#define HK_RETURN         0x0D
#define HK_SHIFT          0x10
#define HK_CONTROL        0x11
#define HK_MENU           0x12
#define HK_PAUSE          0x13
#define HK_ESCAPE         0x1B
#define HK_SPACE          0x20
#define HK_PRIOR          0x21
#define HK_NEXT           0x22
#define HK_END            0x23
#define HK_HOME           0x24
#define HK_LEFT           0x25
#define HK_UP             0x26
#define HK_RIGHT          0x27
#define HK_DOWN           0x28
#define HK_SELECT         0x29
#define HK_PRINT          0x2A
#define HK_EXECUTE        0x2B
#define HK_INSERT         0x2D
#define HK_DELETE         0x2E
#define HK_HELP           0x2F
#define HK_0              0x30
#define HK_1              0x31
#define HK_2              0x32
#define HK_3              0x33
#define HK_4              0x34
#define HK_5              0x35
#define HK_6              0x36
#define HK_7              0x37
#define HK_8              0x38
#define HK_9              0x39
#define HK_A              0x41
#define HK_B              0x42
#define HK_C              0x43
#define HK_D              0x44
#define HK_E              0x45
#define HK_F              0x46
#define HK_G              0x47
#define HK_H              0x48
#define HK_I              0x49
#define HK_J              0x4A
#define HK_K              0x4B
#define HK_L              0x4C
#define HK_M              0x4D
#define HK_N              0x4E
#define HK_O              0x4F
#define HK_P              0x50
#define HK_Q              0x51
#define HK_R              0x52
#define HK_S              0x53
#define HK_T              0x54
#define HK_U              0x55
#define HK_V              0x56
#define HK_W              0x57
#define HK_X              0x58
#define HK_Y              0x59
#define HK_Z              0x5A
#define HK_NUMPAD0        0x60
#define HK_NUMPAD1        0x61
#define HK_NUMPAD2        0x62
#define HK_NUMPAD3        0x63
#define HK_NUMPAD4        0x64
#define HK_NUMPAD5        0x65
#define HK_NUMPAD6        0x66
#define HK_NUMPAD7        0x67
#define HK_NUMPAD8        0x68
#define HK_NUMPAD9        0x69
#define HK_MULTIPLY       0x6A
#define HK_ADD            0x6B
#define HK_SEPARATOR      0x6C
#define HK_SUBTRACT       0x6D
#define HK_DECIMAL        0x6E
#define HK_DIVIDE         0x6F
#define HK_F1             0x70
#define HK_F2             0x71
#define HK_F3             0x72
#define HK_F4             0x73
#define HK_F5             0x74
#define HK_F6             0x75
#define HK_F7             0x76
#define HK_F8             0x77
#define HK_F9             0x78
#define HK_F10            0x79
#define HK_F11            0x7A
#define HK_F12            0x7B
#define HK_NUMLOCK        0x90
#define HK_SCROLL         0x91

extern HMapper<H_KEY,string> KeyMap;

#endif //_H_KEYS_H_
